
Signed-off-by: Maciej Pijanka <maciej.pijanka@gmail.com>

Index: linux-i386/mkelf-linux-i386.c
===================================================================
--- linux-i386/mkelf-linux-i386.c	(wersja 4371)
+++ linux-i386/mkelf-linux-i386.c	(kopia robocza)
@@ -157,14 +157,15 @@
 	return result;
 }
 
+#define MAX_SECT	16
 struct kernel_info
 {
 	int phdrs;
-	void *kernel[4];
-	size_t filesz[4];
-	size_t memsz[4];
-	size_t paddr[4];
-	size_t vaddr[4];
+	void *kernel[MAX_SECT];
+	size_t filesz[MAX_SECT];
+	size_t memsz[MAX_SECT];
+	size_t paddr[MAX_SECT];
+	size_t vaddr[MAX_SECT];
 	size_t entry;
 	size_t switch_64;
 	char *version;
@@ -217,6 +218,8 @@
 		info->memsz[phdrs]   = le64_to_cpu(phdr[i].p_memsz);
 		info->paddr[phdrs]   = le64_to_cpu(phdr[i].p_paddr) & 0xffffff;
 		info->vaddr[phdrs]   = le64_to_cpu(phdr[i].p_vaddr);
+		if (i >= MAX_SECT) 
+			fprintf(stderr, "Out of section storage room, please increase MAX_SECT (to at least %u) and recompile then rerun binary\n", le16_to_cpu(ehdr->e_phnum));
 		phdrs++;
 	}
 
